=== hailort/prepare_externals/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(hailort_prebuild)

set(HAILO_EXTERNALS_EXCLUDE_TARGETS ON)

message("Downloading dependencies to ${HAILO_EXTERNAL_DIR} ...")
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/pybind11.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/catch2.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/spdlog.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/json.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/cpp-httplib.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/dotwriter.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/benchmark.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/readerwriterqueue.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/xxhash.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/eigen.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/cli11.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/protobuf.cmake)
if(CMAKE_SYSTEM_NAME STREQUAL QNX)
    include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/pevents.cmake)
endif()
message("Finished downloading dependencies")
