=== hailort/hailort_server/genai/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

set(HAILO_GENAI_SRC_DIR ${CMAKE_CURRENT_LIST_DIR})
set(HAILORT_GENAI_SERVER_COMPONENTS_SOURCES "")

add_subdirectory(llm)
add_subdirectory(vlm)
add_subdirectory(speech2text)

list(APPEND HAILORT_GENAI_SERVER_COMPONENTS_SOURCES
    ${HAILORT_TOKENIZER_DIR}/hailo_tokenizer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/inference_manager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/llm_server.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/vlm/vlm_server.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/genai_server.cpp
)

set(HAILORT_GENAI_SOURCES
    ${HAILORT_GENAI_SERVER_COMPONENTS_SOURCES}
    ${HAILORT_GENAI_SPEECH2TEXT_COMPONENTS_SOURCES}
    PARENT_SCOPE
)

set(HAILORT_GENAI_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR} PARENT_SCOPE)
