=== debian/changelog ===
h10-pyhailort (5.1.1-1) trixie; urgency=medium

  * Initial release.

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 04 Nov 2025 14:44:16 +0000
